#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Bakku

 Script Function:
	AutoItCannon v.1.0

#ce ----------------------------------------------------------------------------

#include <GUIConstantsEx.au3>
#include <GDIPlus.au3>
#include <WindowsConstants.au3>


Opt('GUIOnEventMode', 1)

Global $sPath = @ScriptDir & "\Images\"
Global $sTitle = "AutoItCannon v.1.0   -   by Bakku (www.autoit.de)"
Global $iWidth = 400
Global $iHeight = 400
Global $iAngle = 0

_GDIPlus_Startup()

$hGUI = GUICreate($sTitle, $iWidth, $iHeight)
GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit")

$hWnd = WinGetHandle($sTitle)

$hGraphics = _GDIPlus_GraphicsCreateFromHWND($hWnd)
$hBitmap = _GDIPlus_BitmapCreateFromGraphics($iWidth, $iHeight, $hGraphics)
$hBuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)

$hBackground = _GDIPlus_ImageLoadFromFile($sPath & "Background.png")
$hCannonU = _GDIPlus_ImageLoadFromFile($sPath & "CannonU.png")
$hCannon = _GDIPlus_ImageLoadFromFile($sPath & "Cannon.png")



GUIRegisterMsg($WM_PAINT, "WM_PAINT")

GUISetState(@SW_SHOW)

While 1 * Sleep(10)
	_GDIPlus_GraphicsClear($hBuffer, 0xFF000000)
	_GDIPlus_GraphicsDrawImageRect($hBuffer, $hBackground, 0, 0, 400, 400)
	_GDIPlus_GraphicsDrawImageRect($hBuffer, $hCannonU, 100, 100, 40, 40)
	$hMatrix = _GDIPlus_MatrixCreate()
	_GDIPlus_MatrixRotate($hMatrix, $iAngle)
	_GDIPlus_GraphicsSetTransform($hBuffer, $hMatrix)
	_GDIPlus_GraphicsDrawImageRect($hBuffer, $hCannon, 100, 100, 40, 40)
	_GDIPlus_MatrixDispose($hMatrix)
	_WinAPI_RedrawWindow($hGUI, 0, 0, $RDW_INTERNALPAINT)
	$iAngle += 1
WEnd

Func WM_PAINT()
	_WinAPI_RedrawWindow($hGUI, 0, 0, $RDW_UPDATENOW)
	_GDIPlus_GraphicsDrawImageRect($hGraphics, $hBitmap, 0, 0, $iWidth, $iHeight)
	_WinAPI_RedrawWindow($hGUI, 0, 0, $RDW_VALIDATE)
EndFunc ;===> WM_PAINT

Func _Exit()
	_GDIPlus_ImageDispose($hCannon)
	_GDIPlus_ImageDispose($hCannonU)
	_GDIPlus_ImageDispose($hBackground)
	_GDIPlus_ImageDispose($hBuffer)
	_GDIPlus_BitmapDispose($hBitmap)
	_GDIPlus_GraphicsDispose($hGraphics)
	_GDIPlus_Shutdown()
	Exit
EndFunc ;===> _Exit


